/******************************************************************************
 *	cscell.c:	\vZppbP[W
 ******************************************************************************
 *	Workroom SX-68K Sample Program Copyright 1994 SHARP
 */
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <event.h>		/* Cxg}𗘗pƂɕKv	*/
#include <sxgraph.h>		/* Otn}l[W𗘗pƂɕKv */
#include <text.h>		/* eLXg}𗘗pƂɕKv	*/
#include <task.h>		/* ^XN}𗘗pƂɕKv	*/
#include "cash.h"		/* ̃vOŗL̃wb_t@C	*/

/******************************************************************************
 *	openCell():	Z̃[N쐬
 ******************************************************************************
 *	:	Mtx *mp		\̍\̂ւ̃|C^
 *		Window *winPtr	EBhE|C^
 *	߂l:	BOOLEAN		= TRUE:  쐬
 *				= FALSE: 쐬s
 */
BOOLEAN openCell(Mtx *mp, Window *winPtr, LPoint lpt, int wide, int height, int fsize)
{
	int errCode;

	static Rect rctext = { 0, 0, 12, 12 };

	/* Z̕\ʒuݒ */
	mp->pos.x_y = lpt;
	/* Z̑傫ݒ */
	mp->cWide = wide;
	mp->cHeight = height;
	/* tHgTCYݒ */
	mp->fontSize = fsize;

	/* ZҏW֌W̃tO */
	mp->mCell.x = 0;
	mp->mCell.y = 0;
	mp->eCell.x = 0;
	mp->eCell.y = 0;
	mp->focus = 0;
	mp->tEdit = NULL;
	mp->edit = FALSE;

	errCode = TMNew2(&rctext, &rctext, &winPtr->graph, &mp->tEdit);
	if (errCode < 0)
		return FALSE;

	TMHide(mp->tEdit);
	(*mp->tEdit)->lenMax = 1;
	(*mp->tEdit)->lineHeight = mp->fontSize * 2;
	(*mp->tEdit)->editMode = 0;	/* ҏW[hʏ\ɂ	*/
	/* t@NVL[ATCe[uݒ肷 */
	(*mp->tEdit)->funcCode = funcKeyTbl;

	return TRUE;
}

/******************************************************************************
 *	closeCell():	Zp
 ******************************************************************************
 *	:	Mtx *mp		\̍\̂ւ̃|C^
 *		Window *winPtr	EBhE|C^
 */
void closeCell(Mtx *mp, Window *winPtr)
{
	GMSetGraph(&winPtr->graph);
	mp->edit = FALSE;
	mp->eCell.x = 0;
	mp->eCell.y = 0;
	mp->focus = 0;
	mp->cAttH = NULL;
	mp->cTitle = NULL;
	mp->cData = NULL;

	if (mp->tEdit != NULL) {
		TMCaret(mp->tEdit, 0);
		TMDispose(mp->tEdit);	/* eLXgp	*/
		mp->tEdit = NULL;
	}

	addUpdate(winPtr, &mp->rcAll);
}

/******************************************************************************
 *	setCellData():	Z̃f[^zݒ
 ******************************************************************************
 *	:	Mtx *mp		\̍\̂ւ̃|C^
 */
void setCellData(Mtx *mp, CAtt *ha, char **data, char ***tBuff)
{
	int i;

	mp->cAttH = ha;
	mp->cTitle = tBuff;
	mp->cData = data;

	/* Ŝ̃N^O߂ */
	mp->rcAll.l.l_t = 0;
	mp->rcAll.d.right = 0;
	for (i = 0; i < mp->cWide; i++)
		mp->rcAll.d.right += (mp->cAttH + i)->length * mp->fontSize + CELLMG * 2;
	mp->rcAll.d.right += OUTFRM * 2;
	mp->rcAll.d.bottom = (mp->fontSize * 2 + CELLMG * 2) * mp->cHeight + (mp->fontSize * 2 + CELLMG * 2 + 1) * 2 + OUTFRM * 2;
	GMSlideRect(&mp->rcAll, mp->pos.x_y);

	/* f[^Z܂ł̃ItZbg */
	mp->offset.p.x = OUTFRM;
	mp->offset.p.y = (mp->fontSize * 2 + CELLMG * 2) + 1 + OUTFRM;
}

/******************************************************************************
 *	drawCell():	ZŜ̕`
 ******************************************************************************
 *	:	Mtx *mp		\̍\̂ւ̃|C^
 */
void drawCell(Mtx *mp)
{
	int i, x, dx;
	CPoint cpt;
	Rect rc;

	GMAPage(G_PAGE0 | G_PAGE1);	/* ANZXy[WOƂPy[Wɂ */
	drawCellFrame(&mp->rcAll, 2, 0);
	rc = mp->rcAll;
	GMInsetRect(&rc, LONGWORD(OUTFRM - 1, OUTFRM - 1));
	drawCellFrame(&rc, 2, 1);

	/* yW͌Œ */
	rc.d.top = mp->pos.p.y + OUTFRM;
	rc.d.bottom = rc.d.top + mp->fontSize * 2 + CELLMG * 2;
	/* ^Cgo[`悷 */
	x = 0;
	for (i = 0; i < mp->cWide; i++) {
		dx = (mp->cAttH + i)->length * mp->fontSize + CELLMG * 2;
		rc.d.left = mp->pos.p.x + OUTFRM;
		rc.d.right = rc.d.left + dx;
		GMSlideRect(&rc, x << 16);
		/* ^Cgt[` */
		drawCellFrame(&rc, 2, 0);
		/* ^Cgetŕ` */
		GMShadowStrZ(*(*mp->cTitle + i), LONGWORD(rc.d.left + CELLMG, rc.d.top + CELLMG));
		x += dx;
	}
	/* f[^Z` */
	for (cpt.y = 0; cpt.y < mp->cHeight; cpt.y++)
		for (cpt.x = 0; cpt.x < mp->cWide; cpt.x++)
			drawCellOne(mp, &cpt);

	/* vp͗` */
	x = 0;
	cpt.y = mp->cHeight;
	rc.d.top = mp->pos.p.y + mp->offset.p.y + mp->cHeight * (mp->fontSize * 2 + CELLMG * 2) + 1;
	rc.d.bottom = rc.d.top + (mp->fontSize * 2 + CELLMG * 2);
	for (i = 0; i < mp->cWide; i++) {
		dx = (mp->cAttH + i)->length * mp->fontSize + CELLMG * 2;
		if ((mp->cAttH + i)->attrib == 0)
			/* l̏ꍇAvzvZ */
			totalCell(mp, i);
		else {
			/* lȊȌꍇ`̂ */
			rc.d.left = mp->pos.p.x + OUTFRM;
			rc.d.right = rc.d.left + dx;
			GMSlideRect(&rc, x << 16);
			/* Z̃t[` */
			drawCellFrame(&rc, (mp->cAttH + i)->attrib, 0);
			cpt.x = i;
			drawCellStr(mp, &rc, &cpt);
		}
		x += dx;
	}
}

/******************************************************************************
 *	drawCellOne():	P̃Z`
 ******************************************************************************
 *	:	Mtx *mp		\̍\̂ւ̃|C^
 *		CPoint *pcpt	Z̈ʒuւ̃|C^
 */
void drawCellOne(Mtx *mp, CPoint *pcpt)
{
	int lastFC, lastBC;
	Rect rc;
	CAtt *pcatt;

	lastFC = GMForeColor(G_BLACK);
	lastBC = GMBackColor(G_LGRAY);
	/* Z̑傫߂ */
	rc.l.l_t = 0;
	rc.d.right = (mp->cAttH + pcpt->x)->length * mp->fontSize + CELLMG * 2;
	rc.d.bottom = mp->fontSize * 2 + CELLMG * 2;

	/* ZʒuɃN^Oړ */
	GMSlideRect(&rc, cptToLpt(mp, pcpt));

	/* Z̃t[` */
	pcatt = mp->cAttH + pcpt->x;
	drawCellFrame(&rc, pcatt->attrib, 0);
	drawCellStr(mp, &rc, pcpt);
	GMForeColor(lastFC);
	GMBackColor(lastBC);
}

/******************************************************************************
 *	drawCellStr():	Zɕ`
 ******************************************************************************
 *	:	Mtx *mp		\̍\̂ւ̃|C^
 *		CPoint *pcpt	Z̈ʒuւ̃|C^
 */
void drawCellStr(Mtx *mp, Rect *prc, CPoint *pcpt)
{
	int lastFC, lastBC;
	Point pt;
	CAtt *pcatt;
	char str[256], *ar;

	lastFC = GMForeColor(G_BLACK);
	lastBC = GMBackColor(G_LGRAY);

	pt.p.x = prc->d.left + CELLMG;
	pt.p.y = prc->d.top + CELLMG;
	/* i[f[^̃|C^擾 */
	pcatt = mp->cAttH + pcpt->x;
	ar = *(mp->cData + pcatt->array);
	switch (pcatt->attrib) {
	case 0:				/* l			*/
		/* lEŏo */
		GMBackColor(G_WHITE);
		sprintf(str, "%*d\0", pcatt->length - 1, *((int *) ar + pcpt->y));
		GMMove(pt.x_y);
		GMDrawStrZ(str);
		break;
	case 1:				/* 		*/
		/* ŏo */
		GMBackColor(G_WHITE);
		strcpy(str, ar + pcpt->y * pcatt->size);
		GMMove(pt.x_y);
		GMDrawStrZ(str);
		break;
	case 2:				/* ^Cg		*/
		/* ^Cgetŏo */
		GMBackColor(G_LGRAY);
		GMShadowStrZ(*(*(mp->cTitle + 1) + pcpt->y), pt.x_y);
		break;
	}
	GMForeColor(lastFC);
	GMBackColor(lastBC);
}

/******************************************************************************
 *	drawCellFrame():	Z̃t[`
 ******************************************************************************
 *	:	Mtx *mp		\̍\̂ւ̃|C^
 *		short kind	t[쐬Z̃f[^̎
 *		short mode	t[̏
 *				= 0: ʏ\
 *				= 1: I
 */
void drawCellFrame(Rect *prc, short kind, short mode)
{
	int lastFC, lastBC, lc, rc;
	Point pt;

	lastFC = GMForeColor(G_BLACK);
	lastBC = GMBackColor(G_LGRAY);

	switch (kind) {
	case 0:
	case 1:
		GMForeColor(G_WHITE);
		GMFillRect(prc);
		GMForeColor(G_BLACK);
		GMMove(LONGWORD(prc->d.right - 1, prc->d.top));
		GMLine(LONGWORD(prc->d.right - 1, prc->d.bottom - 1));
		GMMove(LONGWORD(prc->d.left, prc->d.bottom-1));
		GMLine(LONGWORD(prc->d.right - 1, prc->d.bottom - 1));
		break;
	case 2:
		if (mode == 1) {	/* mode = 1ȂAE񂾃N^O */
			lc = G_BLACK;
			rc = G_WHITE;
		} else {		/* mode = 0ȂAoN^O */
			lc = G_WHITE;
			rc = G_BLACK;
		}
		/* 򕔕 */
		lastFC = GMForeColor(lc);
		pt.p.x = prc->d.left;
		pt.p.y = prc->d.bottom - 1;
		GMMove(pt.x_y);
		pt.p.y = prc->d.top;
		GMLine(pt.x_y);
		pt.p.x = prc->d.right - 2;
		GMLine(pt.x_y);
		/* Ɖe̋ */
		GMForeColor(G_DGRAY);
		pt.p.x++;
		GMMove(pt.x_y);
		GMLine(pt.x_y);
		/* e̕ */
		GMForeColor(rc);
		pt.p.y++;
		GMMove(pt.x_y);
		pt.p.y = prc->d.bottom - 1;
		GMLine(pt.x_y);
		pt.p.x = prc->d.left + 1;
		GMLine(pt.x_y);
		/* Ɖe̋ */
		GMForeColor(G_DGRAY);
		pt.p.x--;
		GMMove(pt.x_y);
		GMLine(pt.x_y);
	}
	GMForeColor(lastFC);
	GMBackColor(lastBC);
}

/******************************************************************************
 *	cptToLpt():	Z̍W畨W߂
 ******************************************************************************
 *	:	Mtx *mp		\̍\̂ւ̃|C^
 *		CPoint *pcpt	Z̈ʒuւ̃|C^
 *	߂l:	LPoint
 */
LPoint cptToLpt(Mtx *mp, CPoint *pcpt)
{
	int i;
	Point pt;

	/* c̈ʒuZo */
	pt.p.y = (mp->fontSize * 2 + CELLMG * 2) * pcpt->y;
	/* ̈ʒuZo */
	pt.p.x = 0;
	for (i = 0; i < pcpt->x; i++)
		pt.p.x += (mp->cAttH + i)->length * mp->fontSize + CELLMG * 2;

	/* \JnWZ */
	pt.p.x += mp->pos.p.x + mp->offset.p.x;
	pt.p.y += mp->pos.p.y + mp->offset.p.y;
	return pt.x_y;
}

/******************************************************************************
 *	focusOn():	ҏẄݒ
 ******************************************************************************
 *	:	Mtx *mp		\̍\̂ւ̃|C^
 *		CPoint *pcpt	Z̈ʒuւ̃|C^
 */
void focusOn(Mtx *mp, CPoint *pcpt)
{
	Rect rc;
	CAtt *pcatt;
	char str[256], *ar;

	pcatt = mp->cAttH + pcpt->x;
	if (mp->focus == 2 || pcatt->attrib > 1)
		/* łɕҏWԁ^lAȊȎ */
		return;

	mp->eCell = *pcpt;
	if (mp->focus == 0) {
		mp->focus++;
		/* IԂ̂PiK */
		return;
	}
	mp->focus = 2;
	/* IԂ̑QiK */
	/* ҏWZ̃N^O߂ */
	rc.l.l_t = 0;
	rc.d.right = pcatt->length * mp->fontSize + CELLMG * 2;
	rc.d.bottom = mp->fontSize * 2 + CELLMG * 2;
	GMSlideRect(&rc, cptToLpt(mp, pcpt));

	(*mp->tEdit)->lenMax = pcatt->length - 1; /* ҏWݒ */
	GMInsetRect(&rc, LONGWORD(CELLMG, CELLMG));

	/* Z̃f[^ҏWł悤ɕϊ */
	ar = *(mp->cData + pcatt->array);
	switch (pcatt->attrib) {
	case 0:				/* lEŏo	*/
		sprintf(str, "%*d\0", pcatt->length - 1, *((int *) ar + pcpt->y));
		break;
	case 1:				/* ŏo		*/
		strcpy(str, (ar + pcpt->y * pcatt->size));
		break;
	}
	TMSetText(mp->tEdit, str, (int) strlen(str));
	TMSetRect(mp->tEdit, &rc, &rc);
	TMShow(mp->tEdit);
	TMSetSelect(mp->tEdit, 0, (*mp->tEdit)->length, 0);
	TMCaret(mp->tEdit, 1);

	mp->edit = FALSE;
}

/******************************************************************************
 *	focusOff():	ҏWxP
 ******************************************************************************
 *	:	Mtx *mp		\̍\̂ւ̃|C^
 */
void focusOff(Mtx *mp)
{
	int lastFC;
	Rect rc;
	CAtt *pcatt = mp->cAttH + mp->eCell.x;

	if (mp->focus == 0)
		/* ҏW̃ZȂ */
		return;

	if (mp->focus == 2) {
		TMCaret(mp->tEdit, 0);
		TMHide(mp->tEdit);
	}
	/* ҏWZ̃N^O߂ */
	rc.l.l_t = 0;
	rc.d.right = pcatt->length * mp->fontSize + CELLMG * 2;
	rc.d.bottom = mp->fontSize * 2 + CELLMG * 2;
	GMSlideRect(&rc, cptToLpt(mp, &mp->eCell));
	lastFC = GMForeColor(G_WHITE);
	GMFillRect(&rc);
	drawCellOne(mp, &mp->eCell);	/* Z̍ĕ`		*/
	mp->focus--;
	mp->edit = FALSE;
	drawFocus(mp);
	GMForeColor(lastFC);
}

/******************************************************************************
 *	drawFocus():	ҏẄ̕`
 ******************************************************************************
 *	:	Mtx *mp		\̍\̂ւ̃|C^
 */
void drawFocus(Mtx *mp)
{
	int lastBC, lastFC;
	Rect rc, rc2;
	CAtt *pcatt = mp->cAttH + mp->eCell.x;

	if (mp->focus == 0)
		/* ҏW̃ZȂ */
		return;

	/* ҏWZ̃N^O߂ */
	rc.l.l_t = 0;
	rc.d.right = pcatt->length * mp->fontSize + CELLMG * 2;
	rc.d.bottom = mp->fontSize * 2 + CELLMG * 2;
	GMSlideRect(&rc, cptToLpt(mp, &mp->eCell));
	lastFC = GMForeColor(G_BLACK);
	lastBC = GMBackColor(G_WHITE);

	GMFrameRect(&rc);
	rc2.l.l_t = LONGWORD(rc.d.left + 1, rc.d.top + 1);
	rc2.l.r_b = LONGWORD(rc.d.right - 1, rc.d.bottom - 1);
	GMFrameRect(&rc2);

	if (mp->focus == 2) {
		TMCaret(mp->tEdit, 0);
		GMInsetRect(&rc, LONGWORD(CELLMG, CELLMG));
		TMUpDate(mp->tEdit, &rc); /* eLXg̕`悷 */
		TMCaret(mp->tEdit, 1);
	}
	GMBackColor(lastBC);
	GMForeColor(lastFC);
}

/******************************************************************************
 *	mountFocus():	ҏẄ̃f[^zɓo^
 ******************************************************************************
 *	:	Mtx *mp		\̍\̂ւ̃|C^
 */
void mountFocus(Mtx *mp)
{
	int len;
	char str[256];
	/* lƕ̔z|C^p̂ɂ */
	union {
		int *i;
		char *c;
	} ar;

	CAtt *pcatt = mp->cAttH + mp->eCell.x;

	if (mp->focus < 2)
		/* ҏWłȂ */
		return;

	if (!mp->edit)
		/* ҏWĂȂ */
		return;

	/* ar = z̃|C^ */
	ar.c = *(mp->cData + pcatt->array);
	switch (pcatt->attrib) {
	case 0:				/* 𐔒lɕϊđ	*/
		len = TMGetText(mp->tEdit, str, pcatt->length);
		str[len] = 0;
		if (sscanf(str, "%d", ar.i + mp->eCell.y) < 1)
			/* lɕϊłȂ */
			*(ar.i + mp->eCell.y) = 0;
		totalCell(mp, mp->eCell.x); /* vČvZ		*/
		break;
	case 1:				/* zɃRs[		*/
		len = TMGetText(mp->tEdit, str, pcatt->length);
		str[len] = 0;
		strcpy(ar.c + mp->eCell.y * pcatt->size, str);
		break;
	}
	/* m肵Zԍۑ */
	mp->mCell = mp->eCell;
}

/******************************************************************************
 *	cellEvent():	Cxg̃Z̕ҏW
 ******************************************************************************
 *	:	Mtx *mp		\̍\̂ւ̃|C^
 *		TsEvent *ptsev	^XN}CxgR[hւ̃|C^
 *	߂l:	int stat	= 0: ҏWȂ
 *				= 1: ҏW
 *				     i}EX_ECxg̏ꍇ|C^\
 *				     Ȃbit1"1"ɂȂBj
 *				< 0: G[R[h
 */
int cellEvent(Mtx *mp, TsEvent *ptsev)
{
	int lastAP, lastFC, lastBC, lastFK;
	int stat = 0;
	int keyCode;			/* L[R[h			*/
	LPoint lpt;
	CPoint cpt, dcpt;

	/* ANZXy[WOƂPy[Wɂ */
	lastAP = GMAPage(G_PAGE0 | G_PAGE1);
	lastFC = GMForeColor(G_BLACK);
	lastBC = GMBackColor(G_WHITE);
	lastFK = GMFontKind(G_ROM12);
	lpt = GMGlobalToLocal(ptsev->ev.where.x_y);
	cpt = mp->eCell;
	/* Cxgɏs */
	switch (ptsev->ts.what) {
	case E_IDLE:			/* AChCxg	*/
		if (mp->focus == 2)
			stat = TMEventW(mp->tEdit, ptsev);
		break;
	case E_KEYDOWN:			/* L[_ECxg	*/
		if (mp->focus == 0)
			/* ͏ԂłȂꍇ */
			break;
		/* t@NVATCe[uɂL[R[hϊ */
		keyCode = TMKeyToAsk(mp->tEdit, ptsev);
		if (keyCode == -2) {	/* e[uɓo^ĂȂH */
			/* OPT.1L[ꂽH */
			if (ptsev->ev.how & KS_OPT1)
				/* V[gJbgL[̏ */
				mp->edit |= TMEventW(mp->tEdit, ptsev);
			else {
				switch (ptsev->ev.whom.key.ascii) {
				case '\r':	/* ^[L[ENTERL[ */
					if (mp->focus == 2) {
						mountFocus(mp); /* ҏWʂzɕۑ */
						if (mp->edit)
							stat = 1;
						focusOff(mp);
						focusOff(mp);
						/* ̃Z֕ҏẄړ */
						dcpt.x = 0;
						dcpt.y = 1;
						nextCell(mp, &cpt, &dcpt);
					}
					focusOn(mp, &cpt);
					drawFocus(mp);
					break;
				case '\x1b':	/* ESCL[		*/
					/* ͏Ԃ */
					focusOff(mp);
					break;
				default:	/* ̑̃L[		*/
					/* Z̓͂Jn */
					if (mp->focus == 1) {
						focusOn(mp, &mp->eCell);
						drawFocus(mp);
					}
					mp->edit |= TMEventW(mp->tEdit, ptsev);
					mp->edit |= stat;
					break;
				}
			}
		} else if (mp->focus == 1) {
			/* ϊꂽL[R[h̏ꍇ */
			dcpt.x = 0;
			dcpt.y = 0;
			switch (keyCode) {
			case 0x04:	/* K_RIGHT		*/
				dcpt.x = 1;
				goto cursor;
			case 0x13:	/* K_LEFT		*/
				dcpt.x = -1;
				goto cursor;
			case 0x05:	/* K_UP			*/
				dcpt.y = -1;
				goto cursor;
			case 0x18:	/* K_DOWN		*/
				dcpt.y = 1;
cursor:
				mountFocus(mp); /* ҏWʂzɕۑ */
				if (mp->edit)
					stat = 1;
				focusOff(mp);
				focusOff(mp);
				/* ̃Z֕ҏẄړ */
				nextCell(mp, &cpt, &dcpt);
				focusOn(mp, &cpt);
				drawFocus(mp);
				break;
			default:
				/* ̑̃L[̏ꍇ */
				focusOn(mp, &mp->eCell);
				drawFocus(mp);
				mp->edit |= TMEventW(mp->tEdit, ptsev);
				mp->edit |= stat;
			}
		} else {
			/* ̑̃L[̏ꍇ */
			mp->edit |= TMEventW(mp->tEdit, ptsev);
			mp->edit |= stat;
		}
		break;
	case E_MSLDOWN:			/* }EXtg_ECxg	*/
		if (!checkCpt(mp, lpt, &cpt)) {
			/* |C^Z͈̔͊O */
			mountFocus(mp); /* ҏWʂzɕۑ	*/
			if (mp->edit)
				stat = 1;
			focusOff(mp);
			focusOff(mp);
			break;
		}
		if (mp->eCell.x != cpt.x || mp->eCell.y != cpt.y || mp->focus == 0) {
			/* ȑOƈႤZIꂽꍇ */
			mountFocus(mp); /* ҏWʂzɕۑ	*/
			if (mp->edit)
				stat = 1;
			focusOff(mp);
			focusOff(mp);
			/* ҏẄړ */
			focusOn(mp, &cpt);
			drawFocus(mp);
		} else if (mp->focus == 2)
			/* eLXg̃Cxg */
			mp->edit |= TMEventW(mp->tEdit, ptsev);
		else if (mp->focus == 1) {
			/* ҏW\Ԃɂ */
			focusOn(mp, &cpt);
			drawFocus(mp);
			mp->edit |= TMEventW(mp->tEdit, ptsev);
		}
		stat |= 2;
		break;
	case E_MSRDOWN:			/* }EXCg_ECxg	*/
		if (GMPtInRect(&mp->rcAll, lpt)) {
			if (mp->focus == 2) {
				mp->edit |= TMEventW(mp->tEdit, ptsev);
				mp->edit |= stat;
			}
			stat |= 2;
		}
		break;
	}
	GMAPage(lastAP);
	GMForeColor(lastFC);
	GMBackColor(lastBC);
	GMFontKind(lastFK);

	return stat;
}

/******************************************************************************
 *	nextCell():	ҏẄ̈ړ̏
 ******************************************************************************
 *	:	Mtx *mp		\̍\̂ւ̃|C^
 *		CPoint *pcpt	݁^ړ̃Zʒuւ̃|C^
 *		CPoint *pdcpt	Z̈ړւ̃|C^
 *	߂l:	LPoint
 */
void nextCell(Mtx *mp, CPoint *pcpt, CPoint *pdcpt)
{
	/* ړ̃Zʒu߂ */
	pcpt->x += pdcpt->x;
	pcpt->y += pdcpt->y;

	if (pcpt->x < 1)
		/* ōs̏ꍇ */
		pcpt->x = 1;
	else if (pcpt->x >= mp->cWide)
		/* ŉEs̏ꍇ */
		pcpt->x = mp->cWide - 1;
	if (pcpt->y < 0)
		/* ŏs̏ꍇ */
		pcpt->y = 0;
	else if (pcpt->y >= mp->cHeight)
		/* ŉŝ̃Z̏ꍇ */
		pcpt->y = mp->cHeight - 1;
}

/******************************************************************************
 *	checkCpt():	wWŎZԍ߂
 ******************************************************************************
 *	:	Mtx *mp		\̍\̂ւ̃|C^
 *		LPoint lpt	|C^W
 *		CPoint *pcpt	Z̈ʒuւ̃|C^
 *	߂l:	BOOLEAN		= TRUE:  
 *				= FALSE: Z͈͊O
 */
BOOLEAN checkCpt(Mtx *mp, LPoint lpt, CPoint *pcpt)
{
	int x, cx, cy;
	Point pt;

	if (!GMPtInRect(&mp->rcAll, lpt))
		/* OgȌꍇ */
		return FALSE;

	pt.x_y = lpt;
	pt.p.y -= mp->pos.p.y + mp->offset.p.y;
	/* Zԍɕϊ */
	cy = pt.p.y / (mp->fontSize * 2 + CELLMG * 2);
	if (pt.p.y < 0 || cy >= mp->cHeight)
		/* Z͈͊O */
		return FALSE;

	pt.p.x -= mp->pos.p.x + mp->offset.p.x;
	if (pt.p.x < 0)
		/* Z͈͊O */
		return FALSE;

	x = 0;
	for (cx = 0; cx < mp->cWide; cx++) {
		/* |C^̍WZ̍W傫Ȃ܂Ń[v */
		x += (mp->cAttH + cx)->length * mp->fontSize + CELLMG * 2;
		if (pt.p.x < x)
			/* YZ */
			break;
	}
	if (cx >= mp->cWide)
		return FALSE;

	/* ZԍԂ */
	pcpt->x = cx;
	pcpt->y = cy;
	return TRUE;
}

/******************************************************************************
 *	totalCell():	wZ̍v߂
 ******************************************************************************
 *	:	Mtx *mp		\̍\̂ւ̃|C^
		int cx		Zẍʒu
 *	߂l:	BOOLEAN		= TRUE:  
 *				= FALSE: Z͈͊O^Z̑lȊO
 */
BOOLEAN totalCell(Mtx *mp, int cx)
{
	int i, x, lastFC, sum;
	char *ar;
	Rect rc;
	CPoint cpt;
	CAtt *pcatt = mp->cAttH + cx;

	if (cx >= mp->cWide || pcatt->attrib != 0)
		/* Z͈͊O^Z̑lȊO */
		return FALSE;

	/* ar = z̃|C^ */
	ar = *(mp->cData + pcatt->array);
	sum = 0;
	/* vZo */
	for (i = 0; i < mp->cHeight; i++)
		sum += *((int *) ar + i);
	/* vzɕۑ */
	*((int *) ar + mp->cHeight) = sum;

	/* vp͗` */
	lastFC = GMForeColor(G_BLACK);
	rc.d.top = mp->pos.p.y + mp->offset.p.y + mp->cHeight * (mp->fontSize * 2 + CELLMG * 2) + 1;
	rc.d.bottom = rc.d.top + (mp->fontSize * 2 + CELLMG * 2);
	x = 0;
	for (i = 0; i < cx; i++)
		x += (mp->cAttH + i)->length * mp->fontSize + CELLMG * 2;

	rc.d.left = mp->pos.p.x + OUTFRM;
	rc.d.right = rc.d.left + pcatt->length * mp->fontSize + CELLMG * 2;
	GMSlideRect(&rc, x << 16);
	/* Z̃t[` */
	drawCellFrame(&rc, pcatt->attrib, 0);
	cpt.x = cx;
	cpt.y = mp->cHeight;
	drawCellStr(mp, &rc, &cpt);
	GMForeColor(lastFC);
	return TRUE;
}

/******************************************************************************
 *	caretCell():	Z̃J[\̕\
 ******************************************************************************
 *	:	Mtx *mp		\̍\̂ւ̃|C^
 */
void caretCell(Mtx *mp, int flag)
{
	if (mp->focus == 2)
		TMCaret(mp->tEdit, flag);
}

/******************************************************************************
 *	clearCell():	Zf[^̏
 ******************************************************************************
 *	:	Mtx *mp		\̍\̂ւ̃|C^
 *		Window *winPtr	EBhE|C^
 */
void clearCell(Mtx *mp, Window *winPtr)
{
	int cx, cy;
	char *ar;
	CAtt *pcatt;

	/* f[^̈NA */
	for (cx = 0; cx < mp->cWide; cx++) {
		for (cy = 0; cy < mp->cHeight; cy++) {
			pcatt = mp->cAttH + cx;
			/* ar = z̃|C^ */
			ar = *(mp->cData + pcatt->array);
			if (pcatt->attrib == 0)
				*((int *) ar + cy) = 0;
			else if (pcatt->attrib == 1)
				*(ar + cy * pcatt->size) = 0;
		}
	}
	/* \ŜAbvf[g[Wɓo^ */
	addUpdate(winPtr, &mp->rcAll);
}
